/*!
 * @danielhaim/autotoc - v1.4.0 - 2024-03-16
 * git+https://github.com/danielhaim1/autotoc.git
 * Copyright (c) 2024 Daniel Haim, Licensed MIT
 */(()=>{"use strict";var t={497:(t,e,i)=>{var o;const n={Generate:i(352).Generate};t.exports&&(t.exports=n),void 0===(o=function(){return n}.apply(e,[]))||(t.exports=o),"object"==typeof window&&(window.AutoToc=n)},352:(t,e,i)=>{Object.defineProperty(e,"__esModule",{value:!0}),e.Generate=void 0;(o=i(864))&&o.__esModule;var o,n=i(896);e.Generate=class{constructor(t,e,i,o,n,r,s=""){this.contentSelector=t,this.navigationContainer=e,this.tocTitle=i,this.tocIcon=o,this.highlightOffset=n,this.headingDepthLimit=r,this.ignoreSelector=s,this.tocMap=new Map,this.tocTopMap=new Map,this.tocBottomMap=new Map,this.pendingExternalLinks=[]}validateParameters(){if("string"!=typeof this.contentSelector||!document.querySelector(this.contentSelector))throw new Error("Invalid contentSelector: Must be a valid CSS selector string for an existing element.");if("string"!=typeof this.navigationContainer||!document.querySelector(this.navigationContainer))throw new Error("Invalid navigationContainer: Must be a valid CSS selector string for an existing element.");if("string"!=typeof this.tocTitle)throw new Error("Invalid tocTitle: Must be a string.");if(null!==this.tocIcon&&"string"!=typeof this.tocIcon&&void 0!==this.tocIcon)throw new Error("Invalid tocIcon: Must be a string or null.");if("number"!=typeof this.highlightOffset||this.highlightOffset<0)throw new Error("Invalid highlightOffset: Must be a non-negative number.");if("number"!=typeof this.headingDepthLimit||this.headingDepthLimit<1||this.headingDepthLimit>6||!Number.isInteger(this.headingDepthLimit))throw new Error("Invalid headingDepthLimit: Must be an integer between 1 and 6.")}detachEventListeners(){window.removeEventListener("scroll",this.boundScrollListener)}generateUniqueId(t){return(new n.slugify).generate(t.textContent||"")}populateTocMap(){let t=document.querySelectorAll(this.createHeadingSelector());this.ignoreSelector&&(t=Array.from(t).filter((t=>!t.closest(this.ignoreSelector))),console.log("heading ignore:"+t));const e=new Map;t.forEach((t=>{if(!this.ignoreSelector||!t.closest(this.ignoreSelector)){const i=parseInt(t.tagName.substring(1),10),o=t.id||this.generateUniqueId(t),n=t.textContent.trim();this.tocMap.has(o)||e.set(o,{level:i,text:n})}})),this.tocMap=new Map([...this.tocMap,...e]),this.renderTocHtml()}createTocList(t){const e=document.createElement("ol");return 0===t.size||t.forEach(((t,i)=>{const{level:o,text:n}=t,r=n.replace(/^#/,""),s=document.createElement("li");s.className=`toc-list--item level-${o}`,s.setAttribute("role","listitem");const l=document.createElement("a");l.href=`#${i}`,l.textContent=r,s.appendChild(l),e.appendChild(s)})),e}findFirstHeadingLevel(){for(let t=1;t<=this.headingDepthLimit;t++)if(document.querySelector(`${this.contentSelector} > h${t}`))return console.log(t),t;return null}renderTocHtml(){let t=this.findFirstHeadingLevel()||1;const e=document.createElement("ol");e.className="toc-list",e.setAttribute("role","list");let i=[e];const o=this.createTocList(this.tocTopMap),n=this.createTocList(this.tocBottomMap);this.pendingExternalLinks.forEach((t=>{const e=document.createElement("li");e.className="toc-list--item level-level-0",e.setAttribute("role","listitem");const o=document.createElement("a");o.href=`#${t.id}`,o.textContent=t.text,e.appendChild(o),i[i.length-1].appendChild(e)}));const r=(t,e)=>{null!=t?t.appendChild(e):console.error("Attempted to append to a non-existent element.")};this.tocMap.forEach(((e,o)=>{const{level:n,text:r}=e,s=n-t;if(s>0)for(let t=0;t<s;t++){const t=document.createElement("ol");i[i.length-1].lastElementChild.appendChild(t),i.push(t)}else if(s<0)for(let t=0;t<-s;t++)i.pop();const l=r.replace(/^#/,""),c=document.createElement("li");c.className=`toc-list--item level-${n}`,c.setAttribute("role","listitem");const a=document.createElement("a");a.href=`#${o}`,a.textContent=l,c.appendChild(a),i[i.length-1].appendChild(c),t=n}));const s=document.querySelector(this.navigationContainer);s?(s.innerHTML=`<header><h2>${this.tocIcon}<span>${this.tocTitle}</span></h2></header>`,r(s,o),r(s,e),r(s,n),s.setAttribute("role","doc-toc"),s.addEventListener("click",(t=>{if("A"===t.target.tagName&&t.target.getAttribute("href")){t.preventDefault();const e=t.target.getAttribute("href").substring(1);this.scrollToElement(e)}}))):console.error("Navigation container not found")}attachAnchorsToHeadings(){document.querySelectorAll(`${this.createHeadingSelector()}`).forEach((t=>{if(!this.ignoreSelector||!t.closest(this.ignoreSelector)){const e=this.generateUniqueId(t);t.id=e;const i=t.textContent.trim(),o=document.createElement("a");o.href=`#${e}`,o.setAttribute("aria-label",`Anchor link to "${i}"`),o.className="heading-link",o.setAttribute("aria-hidden","true"),o.setAttribute("tabindex","-1");const n=document.createElement("i");n.className="fa-solid fa-link",o.appendChild(n),t.insertBefore(o,t.firstChild)}}))}attachClickListeners(){const t=document.querySelectorAll(".heading-link");t.length>0&&t.forEach((t=>{t.addEventListener("click",this.handleLinkClick.bind(this))}));const e=document.querySelectorAll(`${this.navigationContainer} .toc-list a`);e.length>0&&e.forEach((t=>{t.addEventListener("click",this.handleLinkClick.bind(this))}))}smoothScrollTo(t){const e=window.pageYOffset,i=t-e;let o=null;requestAnimationFrame((function t(n){o||(o=n);const r=n-o,s=Math.min(r/500,1);window.scrollTo(0,e+i*s),r<500&&requestAnimationFrame(t)}))}handleLinkClick(t){t.preventDefault();const e=t.target.closest(".heading-link")?"heading-link":"toc-link",i=t.target.closest("a").getAttribute("href").substring(1),o=document.getElementById(i);if(o){const t=o.getBoundingClientRect().top+window.pageYOffset-this.highlightOffset;console.log(`Link clicked: ${e}`),console.log(`Scroll target position: ${t}px`),this.smoothScrollTo(t)}}createHeadingSelector(){let t=Array.from({length:this.headingDepthLimit},((t,e)=>`${this.contentSelector} h${e+1}`));return this.ignoreSelector&&(t=t.map((t=>`${t}:not(${this.ignoreSelector})`))),t.join(", ")}scrollToElement(t){const e=document.getElementById(t);if(e){this.highlightOffset;const t=e.offsetTop-window.innerHeight/2+e.clientHeight/2;window.scrollTo({top:t,behavior:"smooth"})}}highlightActiveSection(){const t=this.highlightOffset,e=document.querySelectorAll(`${this.contentSelector} h1[id], ${this.contentSelector} h2[id], ${this.contentSelector} h3[id], ${this.contentSelector} h4[id], ${this.contentSelector} h5[id], ${this.contentSelector} h6[id]`),i=Array.from(e).filter((t=>!!document.querySelector(`a[href="#${t.id}"]`))),o=i[i.length-1];let n=!!o&&window.pageYOffset>=o.offsetTop+o.offsetHeight-t;if(i.forEach(((e,o)=>{const r=e.getAttribute("id"),s=document.querySelector(`${this.navigationContainer} .toc-list--item a[href="#${r}"]`),l=i[o+1],c=window.pageYOffset>=e.offsetTop-t;let a=l?window.pageYOffset>=l.offsetTop-t:n;!l&&n&&(a=!1),s&&(c&&!a?s.classList.add("active"):s.classList.remove("active"))})),n&&o){const t=o.getAttribute("id"),e=document.querySelector(`${this.navigationContainer} .toc-list--item a[href="#${t}"]`);e&&!e.classList.contains("active")&&e.classList.add("active")}}addContentToToc(t,e,i){this.tocMap.has(e)||(this.tocMap.set(e,{level:t,text:i}),this.renderTocHtml())}addExternalLinksToToc(t,e="bottom",i="level-0"){if(!Array.isArray(t))throw new Error("Invalid links: Must be an array of link objects.");"top"===e?t.forEach((t=>{if("object"!=typeof t||!t.id||!t.text)throw new Error("Invalid link format: Each link object must have 'id' and 'text' properties.");this.tocTopMap.has(t.id)||this.tocTopMap.set(t.id,{level:i,text:t.text})})):t.forEach((t=>{if("object"!=typeof t||!t.id||!t.text)throw new Error("Invalid link format: Each link object must have 'id' and 'text' properties.");this.tocBottomMap.has(t.id)||this.tocBottomMap.set(t.id,{level:i,text:t.text})})),this.renderTocHtml()}initializeScrollHighlighting(){this.boundHighlightActiveSection=this.highlightActiveSection.bind(this);const t=this.boundHighlightActiveSection;window.addEventListener("scroll",t)}removeEmptyLists(){const t=document.querySelector(this.navigationContainer);if(t){t.querySelectorAll("ol").forEach((t=>{0===t.children.length&&t.parentNode.removeChild(t)}))}}initialize(){this.validateParameters(),this.attachAnchorsToHeadings(),this.populateTocMap(),this.renderTocHtml(),this.initializeScrollHighlighting(),this.removeEmptyLists(),this.attachClickListeners()}}},864:t=>{t.exports=require("@danielhaim/modulator")},896:t=>{t.exports=require("@danielhaim/slugify/src/index.js")}},e={};var i=function i(o){var n=e[o];if(void 0!==n)return n.exports;var r=e[o]={exports:{}};return t[o](r,r.exports,i),r.exports}(497);module.exports=i})();